# author        = Tran Tuan Anh
# version       = 0.2 for Mac
import os

from tempfile import mkstemp
from shutil import move
from os import remove, close

PATH = '/etc/hosts'


def replace(file, pattern, subst):
	fh, abs_path = mkstemp()
	new_file = open(abs_path,'w')
	old_file = open(file)
	for line in old_file:
		new_file.write(line.replace(pattern, subst))
	new_file.close()
	close(fh)
	old_file.close()
	remove(file)
	move(abs_path, file)

def checkPatch():
	f=open(PATH, 'r')
	while 1:
		line = f.readline()
		if not line: break
		#print line,
		if "facebook.com" in line:
			return True
	f.close()
	return False

def removePatch():
	f=open(PATH)
	while 1:
		line = f.readline()
		if not line: break
		if "facebook.com" in line or "#Facebook" in line:
			replace(PATH, line, '')

def processPatch():
	try:
		f=open(PATH, 'a')
		f.write('#Facebook accepting\n')
		f.write('153.16.15.71 facebook.com\n')
		f.write('153.16.15.71 www.facebook.com\n')
		f.write('153.16.15.71 apps.facebook.com\n')
		f.write('153.16.15.71 login.facebook.com\n')
		f.write('153.16.15.71 www.logins.facebook.com\n')
		f.write('153.16.15.71 www.connect.facebook.com\n')
		f.write('153.16.15.71 upload.facebook.com\n')
		f.write('153.16.15.71 graph.facebook.com\n')
		f.write('153.16.15.71 static.ak.connect.facebook.com\n')
		f.write('153.16.15.71 developers.facebook.com\n')
		f.write('153.16.15.71 error.facebook.com\n')
		f.write('153.16.15.71 register.facebook.com\n')
		f.write('153.16.15.71 bigzipfiles.facebook.com\n')
		f.write('153.16.15.71 pixel.facebook.com\n')
		f.close()
		return True
	except:
		return False

def makePatch():
	try:
		processPatch()
		print "Legend! We patched your mac perfectly."
	except:
		print "Not for sure, we got some problems. Contact the author if you want to bother him :)"
		pass
	try:
		x = raw_input("Flush cache (require admin privilege)? (y/N) ")
		if x == 'y' or x == 'Y':
			cmd = "sudo dscacheutil -flushcache"
			os.system(cmd)
	except:
		pass



print """***********************\n\
VaoFB version 0.2\n\
This program is a small utility for easy-accepting-Facebook in Vietnam.\n\
It's written by anhtran in Python. Follow me on Twitter: @anhtt.\n\
Website: http://vaofacebook.com\n\
***********************\n """

if checkPatch():
	#print PATH + "\n",
	x = raw_input("You've patched hosts file before. Do you want to erase the old patch? (y/N) ")
	if x == 'y' or x == 'Y':
		removePatch()
		y = raw_input("Run the patch now? (y/N) ")
		if y == 'y' or y == 'Y':
			makePatch()
		else:
			pass
	else:
		pass
else:
	makePatch()


raw_input('Press Enter to exit...')